<?php
/**
 * A Magento 2 module named FiloBlu/Cegid
 * Copyright (C) 2019  2019
 * 
 * This file is part of FiloBlu/Cegid.
 * 
 * FiloBlu/Cegid is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace FiloBlu\Cegid\Model;

use FiloBlu\Cegid\Api\Data\CegidInterface;
use FiloBlu\Cegid\Api\Data\CegidInterfaceFactory;
use Magento\Framework\Api\DataObjectHelper;

class Cegid extends \Magento\Framework\Model\AbstractModel
{

    protected $cegidDataFactory;

    protected $dataObjectHelper;

    protected $_eventPrefix = 'filoblu_cegid_cegid';

    /**
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param CegidInterfaceFactory $cegidDataFactory
     * @param DataObjectHelper $dataObjectHelper
     * @param \FiloBlu\Cegid\Model\ResourceModel\Cegid $resource
     * @param \FiloBlu\Cegid\Model\ResourceModel\Cegid\Collection $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        CegidInterfaceFactory $cegidDataFactory,
        DataObjectHelper $dataObjectHelper,
        \FiloBlu\Cegid\Model\ResourceModel\Cegid $resource,
        \FiloBlu\Cegid\Model\ResourceModel\Cegid\Collection $resourceCollection,
        array $data = []
    ) {
        $this->cegidDataFactory = $cegidDataFactory;
        $this->dataObjectHelper = $dataObjectHelper;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Retrieve cegid model with cegid data
     * @return CegidInterface
     */
    public function getDataModel()
    {
        $cegidData = $this->getData();
        
        $cegidDataObject = $this->cegidDataFactory->create();
        $this->dataObjectHelper->populateWithArray(
            $cegidDataObject,
            $cegidData,
            CegidInterface::class
        );
        
        return $cegidDataObject;
    }
}
