define([
    'Magento_Ui/js/form/element/abstract',
    'mage/url',
    'ko',
    'jquery',
    'jquery/ui',
    'mage/validation'
], function (Abstract, url, ko, $, ui, validation) {
    'use strict';

    ko.bindingHandlers.resellerAutoComplete = {

        init: function (element, valueAccessor) {
            let settings = valueAccessor();
            let selectedReseller = settings.selected;
            let updateElementValueWithLabel = function (event, ui) {
                event.preventDefault();
                $(element).val(ui.item.label);
                $.validator.validateSingleElement($(element));
                if (typeof ui.item !== 'undefined') {
                    selectedReseller(ui.item.value);
                }
            };

            $(element).autocomplete({
                source: function (request, response) {
                    $.get('/filoblu_cegid/seller/search/q/' + request.term, function (data) {
                        response(data);
                    });
                },
                position: {my: 'left top', at: 'left bottom', collision: "flip"},
                messages: {
                    noResults: '',
                    results: function () {
                        return ''
                    }
                },
                select: function (event, ui) {
                    updateElementValueWithLabel(event, ui)
                }
            });
        }
    };

    return Abstract.extend({
        selectedReseller: ko.observable(''),
        getResellers: function () {
            return [];
        }
    });
});